"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DatePickerYear = DatePickerYear;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _utils = require("@uiw/utils");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["prefixCls", "panelNum", "className", "panelDate", "onSelected"];
function DatePickerYear(props) {
  var _props$prefixCls = props.prefixCls,
    prefixCls = _props$prefixCls === void 0 ? 'w-datepicker' : _props$prefixCls,
    _props$panelNum = props.panelNum,
    panelNum = _props$panelNum === void 0 ? [-7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10] : _props$panelNum,
    className = props.className,
    panelDate = props.panelDate,
    _props$onSelected = props.onSelected,
    onSelected = _props$onSelected === void 0 ? _utils.noop : _props$onSelected,
    other = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var _useState = (0, _react.useState)(props.panelDate),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    activeYear = _useState2[0],
    setActiveYear = _useState2[1];
  function handleSelected(year, idx) {
    if (idx === 0 || idx === panelNum.length - 1) {
      var date = new Date(activeYear);
      date.setFullYear(year);
      setActiveYear(date);
    } else {
      onSelected(year);
    }
  }
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", (0, _objectSpread2["default"])((0, _objectSpread2["default"])({
    className: [prefixCls ? "".concat(prefixCls, "-year") : null, className].filter(Boolean).join(' ').trim()
  }, other), {}, {
    children: panelNum && panelNum.map(function (_, idx) {
      var selectedYear = activeYear.getFullYear();
      var year = selectedYear + panelNum[idx];
      return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: [selectedYear === year ? 'selected' : null, idx === 0 || idx === panelNum.length - 1 ? 'paging' : null].filter(Boolean).join(' ').trim(),
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
          onClick: function onClick() {
            return handleSelected(year, idx);
          },
          children: year
        })
      }, idx);
    })
  }));
}