import React from 'react';
import { IProps, HTMLDivProps } from '@uiw/utils';
import { TimePickerPanelProps } from '@uiw/react-time-picker';
import { DatePickerDayProps, DatePickerDayDateSource } from './DatePickerDay';
import { DatePickerCaptionType } from './DatePickerCaption';
import './style/index.less';
export * from './DatePickerDay';
export * from './DatePickerMonth';
export * from './DatePickerYear';
export * from './DatePickerCaption';
export interface DatePickerShowTimeProps extends TimePickerPanelProps {
    format?: string;
}
export interface DatePickerProps extends IProps, Omit<HTMLDivProps, 'onChange'> {
    onChange?: (selectedDate?: Date, dateSource?: DatePickerDayDateSource) => void;
    renderDay?: DatePickerDayProps['renderDay'];
    disabledDate?: DatePickerDayProps['disabledDate'];
    showTime?: DatePickerShowTimeProps | boolean;
    monthLabel?: React.ReactNode[];
    weekday?: string[];
    weekTitle?: string[];
    date?: Date;
    panelDate?: Date;
    today?: Date;
    todayButton?: string;
    onPanelChange?: (date?: Date, mode?: 'next' | 'prev') => void;
}
export interface DatePickerState {
    panelDate?: Date;
    date?: Date;
    type?: 'day' | 'time' | DatePickerCaptionType;
}
export default function DatePicker(props: DatePickerProps): React.JSX.Element;
